MEMORY
{
  UNPLACED_SECTIONS (wx) : ORIGIN = 0x100000000, LENGTH = 0
  RAM (wx) : ORIGIN = 0x20000000, LENGTH = 0x00040000
}

SECTIONS
{
  __RAM_segment_start__ = 0x20000000;
  __RAM_segment_end__ = 0x20040000;
  __RAM_segment_size__ = 0x00040000;

  __HEAPSIZE__ = 256;
  __STACKSIZE_PROCESS__ = 0;
  __STACKSIZE__ = 256;

  __PrgCode_load_start__ = ALIGN(__RAM_segment_start__ , 4);
  PrgCode ALIGN(__RAM_segment_start__ , 4) : AT(ALIGN(__RAM_segment_start__ , 4))
  {
    __PrgCode_start__ = .;
    KEEP(*(PrgCode PrgCode.*))
    KEEP(*(.text .text.*))
    KEEP(*(.rodata .rodata.*))
  }
  __PrgCode_end__ = __PrgCode_start__ + SIZEOF(PrgCode);
  __PrgCode_size__ = SIZEOF(PrgCode);
  __PrgCode_load_end__ = __PrgCode_end__;

  . = ASSERT(__PrgCode_start__ == __PrgCode_end__ || (__PrgCode_end__ >= __RAM_segment_start__ && __PrgCode_end__ <= __RAM_segment_end__) , "error: PrgCode is too large to fit in RAM memory segment");

  __PrgData_load_start__ = ALIGN(__PrgCode_end__ , 4);
  PrgData ALIGN(__PrgCode_end__ , 4) : AT(ALIGN(__PrgCode_end__ , 4))
  {
    __PrgData_start__ = .;
    KEEP(*(PrgData PrgData.*))
    KEEP(*(.data .data.*))
    KEEP(*(.bss .bss.*))
  }
  __PrgData_end__ = __PrgData_start__ + SIZEOF(PrgData);
  __PrgData_size__ = SIZEOF(PrgData);
  __PrgData_load_end__ = __PrgData_end__;

  . = ASSERT(__PrgData_start__ == __PrgData_end__ || (__PrgData_end__ >= __RAM_segment_start__ && __PrgData_end__ <= __RAM_segment_end__) , "error: PrgData is too large to fit in RAM memory segment");

  __DevDscr_load_start__ = ALIGN(__PrgData_end__ , 4);
  DevDscr ALIGN(__PrgData_end__ , 4) : AT(ALIGN(__PrgData_end__ , 4))
  {
    __DevDscr_start__ = .;
    KEEP(*(DevDscr DevDscr.*))
  }
  __DevDscr_end__ = __DevDscr_start__ + SIZEOF(DevDscr);
  __DevDscr_size__ = SIZEOF(DevDscr);
  __DevDscr_load_end__ = __DevDscr_end__;

    __tbss_load_start__ = ALIGN(__DevDscr_end__ , 4);
  .tbss ALIGN(__DevDscr_end__ , 4) (NOLOAD) : AT(ALIGN(__DevDscr_end__ , 4))
  {
    __tbss_start__ = .;
    *(.tbss .tbss.*)
  }
  __tbss_end__ = __tbss_start__ + SIZEOF(.tbss);
  __tbss_size__ = SIZEOF(.tbss);
  __tbss_load_end__ = __tbss_end__;

  __heap_load_start__ = ALIGN(__tbss_end__ , 4);
  .heap ALIGN(__tbss_end__ , 4) (NOLOAD) : AT(ALIGN(__tbss_end__ , 4))
  {
    __heap_start__ = .;
    *(.heap .heap.*)
    . = ALIGN(MAX(__heap_start__ + __HEAPSIZE__ , .), 4);
  }
  __heap_end__ = __heap_start__ + SIZEOF(.heap);
  __heap_size__ = SIZEOF(.heap);
  __heap_load_end__ = __heap_end__;

  __RAM_segment_used_end__ = ALIGN(__PrgData_end__ , 4) + SIZEOF(DevDscr) + SIZEOF(.heap);
  __RAM_segment_used_size__ = __RAM_segment_used_end__ - __RAM_segment_start__;

  . = ASSERT(__DevDscr_start__ == __DevDscr_end__ || (__DevDscr_end__ >= __RAM_segment_start__ && __DevDscr_end__ <= __RAM_segment_end__) , "error: DevDscr is too large to fit in RAM memory segment");

}

